Skip to content
Start here

List IP Access rules

client.Firewall.AccessRules.List(ctx, params) (*V4PagePaginationArray[AccessRuleListResponse], error)
GET/{accounts_or_zones}/{account_or_zone_id}/firewall/access_rules/rules

Fetches IP Access rules of an account or zone. These rules apply to all the zones in the account or zone. You can filter the results using several optional parameters.

Security
API Token

The preferred authorization scheme for interacting with the Cloudflare API. Create a token.

Example:Authorization: Bearer Sn3lZJTBX6kkg7OdcBUAxOO963GEIyGQqnFTOFYY
API Email + API Key

The previous authorization scheme for interacting with the Cloudflare API, used in conjunction with a Global API key.

Example:X-Auth-Email: user@example.com

The previous authorization scheme for interacting with the Cloudflare API. When possible, use API tokens instead of Global API keys.

Example:X-Auth-Key: 144c9defac04969c7bfad8efaa8ea194
Accepted Permissions (at least one required)
Account Firewall Access Rules WriteAccount Firewall Access Rules Read
ParametersExpand Collapse
params AccessRuleListParams
AccountID param.Field[string]optional

Path param: The Account ID to use for this endpoint. Mutually exclusive with the Zone ID.

ZoneID param.Field[string]optional

Path param: The Zone ID to use for this endpoint. Mutually exclusive with the Account ID.

Configuration param.Field[AccessRuleListParamsConfiguration]optional

Query param

Target AccessRuleListParamsConfigurationTargetoptional

Defines the target to search in existing rules.

One of the following:
const AccessRuleListParamsConfigurationTargetIP AccessRuleListParamsConfigurationTarget = "ip"
const AccessRuleListParamsConfigurationTargetIPRange AccessRuleListParamsConfigurationTarget = "ip_range"
const AccessRuleListParamsConfigurationTargetASN AccessRuleListParamsConfigurationTarget = "asn"
const AccessRuleListParamsConfigurationTargetCountry AccessRuleListParamsConfigurationTarget = "country"
Value stringoptional

Defines the target value to search for in existing rules: an IP address, an IP address range, or a country code, depending on the provided configuration.target. Notes: You can search for a single IPv4 address, an IP address range with a subnet of '/16' or '/24', or a two-letter ISO-3166-1 alpha-2 country code.

Direction param.Field[AccessRuleListParamsDirection]optional

Query param: Defines the direction used to sort returned rules.

const AccessRuleListParamsDirectionAsc AccessRuleListParamsDirection = "asc"
const AccessRuleListParamsDirectionDesc AccessRuleListParamsDirection = "desc"
Match param.Field[AccessRuleListParamsMatch]optional

Query param: Defines the search requirements. When set to all, all the search requirements must match. When set to any, only one of the search requirements has to match.

const AccessRuleListParamsMatchAny AccessRuleListParamsMatch = "any"
const AccessRuleListParamsMatchAll AccessRuleListParamsMatch = "all"
Mode param.Field[AccessRuleListParamsMode]optional

Query param: The action to apply to a matched request.

const AccessRuleListParamsModeBlock AccessRuleListParamsMode = "block"
const AccessRuleListParamsModeChallenge AccessRuleListParamsMode = "challenge"
const AccessRuleListParamsModeWhitelist AccessRuleListParamsMode = "whitelist"
const AccessRuleListParamsModeJSChallenge AccessRuleListParamsMode = "js_challenge"
const AccessRuleListParamsModeManagedChallenge AccessRuleListParamsMode = "managed_challenge"
Notes param.Field[string]optional

Query param: Defines the string to search for in the notes of existing IP Access rules. Notes: For example, the string 'attack' would match IP Access rules with notes 'Attack 26/02' and 'Attack 27/02'. The search is case insensitive.

Order param.Field[AccessRuleListParamsOrder]optional

Query param: Defines the field used to sort returned rules.

const AccessRuleListParamsOrderConfigurationTarget AccessRuleListParamsOrder = "configuration.target"
const AccessRuleListParamsOrderConfigurationValue AccessRuleListParamsOrder = "configuration.value"
const AccessRuleListParamsOrderMode AccessRuleListParamsOrder = "mode"
Page param.Field[float64]optional

Query param: Defines the requested page within paginated list of results.

PerPage param.Field[float64]optional

Query param: Defines the maximum number of results requested.

ReturnsExpand Collapse
type AccessRuleListResponse struct{…}
ID string

The unique identifier of the IP Access rule.

maxLength32
AllowedModes []AccessRuleListResponseAllowedMode

The available actions that a rule can apply to a matched request.

One of the following:
const AccessRuleListResponseAllowedModeBlock AccessRuleListResponseAllowedMode = "block"
const AccessRuleListResponseAllowedModeChallenge AccessRuleListResponseAllowedMode = "challenge"
const AccessRuleListResponseAllowedModeWhitelist AccessRuleListResponseAllowedMode = "whitelist"
const AccessRuleListResponseAllowedModeJSChallenge AccessRuleListResponseAllowedMode = "js_challenge"
const AccessRuleListResponseAllowedModeManagedChallenge AccessRuleListResponseAllowedMode = "managed_challenge"
Configuration AccessRuleListResponseConfiguration

The rule configuration.

One of the following:
type AccessRuleIPConfiguration struct{…}
Target AccessRuleIPConfigurationTargetoptional

The configuration target. You must set the target to ip when specifying an IP address in the rule.

Value stringoptional

The IP address to match. This address will be compared to the IP address of incoming requests.

type IPV6Configuration struct{…}
Target IPV6ConfigurationTargetoptional

The configuration target. You must set the target to ip6 when specifying an IPv6 address in the rule.

Value stringoptional

The IPv6 address to match.

type AccessRuleCIDRConfiguration struct{…}
Target AccessRuleCIDRConfigurationTargetoptional

The configuration target. You must set the target to ip_range when specifying an IP address range in the rule.

Value stringoptional

The IP address range to match. You can only use prefix lengths /16 and /24 for IPv4 ranges, and prefix lengths /32, /48, and /64 for IPv6 ranges.

type ASNConfiguration struct{…}
Target ASNConfigurationTargetoptional

The configuration target. You must set the target to asn when specifying an Autonomous System Number (ASN) in the rule.

Value stringoptional

The AS number to match.

type CountryConfiguration struct{…}
Target CountryConfigurationTargetoptional

The configuration target. You must set the target to country when specifying a country code in the rule.

Value stringoptional

The two-letter ISO-3166-1 alpha-2 code to match. For more information, refer to IP Access rules: Parameters.

Mode AccessRuleListResponseMode

The action to apply to a matched request.

One of the following:
const AccessRuleListResponseModeBlock AccessRuleListResponseMode = "block"
const AccessRuleListResponseModeChallenge AccessRuleListResponseMode = "challenge"
const AccessRuleListResponseModeWhitelist AccessRuleListResponseMode = "whitelist"
const AccessRuleListResponseModeJSChallenge AccessRuleListResponseMode = "js_challenge"
const AccessRuleListResponseModeManagedChallenge AccessRuleListResponseMode = "managed_challenge"
CreatedOn Timeoptional

The timestamp of when the rule was created.

formatdate-time
ModifiedOn Timeoptional

The timestamp of when the rule was last modified.

formatdate-time
Notes stringoptional

An informative summary of the rule, typically used as a reminder or explanation.

Scope AccessRuleListResponseScopeoptional

All zones owned by the user will have the rule applied.

ID stringoptional

Defines an identifier.

maxLength32
Email stringoptional

The contact email address of the user.

maxLength90
Type AccessRuleListResponseScopeTypeoptional

Defines the scope of the rule.

One of the following:
const AccessRuleListResponseScopeTypeUser AccessRuleListResponseScopeType = "user"
const AccessRuleListResponseScopeTypeOrganization AccessRuleListResponseScopeType = "organization"

List IP Access rules

package main

import (
  "context"
  "fmt"

  "github.com/cloudflare/cloudflare-go"
  "github.com/cloudflare/cloudflare-go/firewall"
  "github.com/cloudflare/cloudflare-go/option"
)

func main() {
  client := cloudflare.NewClient(
    option.WithAPIToken("Sn3lZJTBX6kkg7OdcBUAxOO963GEIyGQqnFTOFYY"),
  )
  page, err := client.Firewall.AccessRules.List(context.TODO(), firewall.AccessRuleListParams{

  })
  if err != nil {
    panic(err.Error())
  }
  fmt.Printf("%+v\n", page)
}
{
  "errors": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "result": [
    {
      "id": "92f17202ed8bd63d69a66b86a49a8f6b",
      "allowed_modes": [
        "whitelist",
        "block",
        "challenge",
        "js_challenge",
        "managed_challenge"
      ],
      "configuration": {
        "target": "ip",
        "value": "198.51.100.4"
      },
      "mode": "challenge",
      "created_on": "2014-01-01T05:20:00.12345Z",
      "modified_on": "2014-01-01T05:20:00.12345Z",
      "notes": "This rule is enabled because of an event that occurred on date X.",
      "scope": {
        "id": "023e105f4ecef8ad9ca31a8372d0c353",
        "email": "user@example.com",
        "type": "user"
      }
    }
  ],
  "success": true,
  "result_info": {
    "count": 1,
    "page": 1,
    "per_page": 20,
    "total_count": 2000
  }
}
Returns Examples
{
  "errors": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "result": [
    {
      "id": "92f17202ed8bd63d69a66b86a49a8f6b",
      "allowed_modes": [
        "whitelist",
        "block",
        "challenge",
        "js_challenge",
        "managed_challenge"
      ],
      "configuration": {
        "target": "ip",
        "value": "198.51.100.4"
      },
      "mode": "challenge",
      "created_on": "2014-01-01T05:20:00.12345Z",
      "modified_on": "2014-01-01T05:20:00.12345Z",
      "notes": "This rule is enabled because of an event that occurred on date X.",
      "scope": {
        "id": "023e105f4ecef8ad9ca31a8372d0c353",
        "email": "user@example.com",
        "type": "user"
      }
    }
  ],
  "success": true,
  "result_info": {
    "count": 1,
    "page": 1,
    "per_page": 20,
    "total_count": 2000
  }
}